import { ExtendedCompletionTriggerKind } from '../../lsp';
import * as CodeMirror from 'codemirror';
import { CodeMirrorIntegration } from '../../editor_integration/codemirror';
import { JupyterFrontEnd } from '@jupyterlab/application';
import { IEditorChangedData, WidgetAdapter } from '../../adapters/adapter';
import { LSPConnector } from './completion_handler';
import { CompletionHandler, ICompletionManager } from '@jupyterlab/completer';
import { IDocumentWidget } from '@jupyterlab/docregistry';
import { FeatureSettings, IFeatureLabIntegration } from '../../feature';
import { CodeCompletion as LSPCompletionSettings } from '../../_completion';
import { IDocumentConnectionData } from '../../connection_manager';
import { ILSPAdapterManager, ILSPLogConsole } from '../../tokens';
import { ILSPCompletionThemeManager } from '@krassowski/completion-theme/lib/types';
import { LSPCompletionRenderer } from './renderer';
import { IRenderMimeRegistry } from '@jupyterlab/rendermime';
import { LSPCompleterModel } from './model';
import { LazyCompletionItem } from './item';
export declare class CompletionCM extends CodeMirrorIntegration {
    private _completionCharacters;
    get settings(): FeatureSettings<LSPCompletionSettings>;
    get completionCharacters(): string[];
    afterChange(change: CodeMirror.EditorChange): void;
}
export declare class CompletionLabIntegration implements IFeatureLabIntegration {
    private app;
    private completionManager;
    settings: FeatureSettings<LSPCompletionSettings>;
    private adapterManager;
    private completionThemeManager;
    private console;
    private renderMimeRegistry;
    protected current_completion_connector: LSPConnector;
    protected current_completion_handler: CompletionHandler;
    protected current_adapter: WidgetAdapter<IDocumentWidget>;
    protected renderer: LSPCompletionRenderer;
    constructor(app: JupyterFrontEnd, completionManager: ICompletionManager, settings: FeatureSettings<LSPCompletionSettings>, adapterManager: ILSPAdapterManager, completionThemeManager: ILSPCompletionThemeManager, console: ILSPLogConsole, renderMimeRegistry: IRenderMimeRegistry);
    active_completion_changed(renderer: LSPCompletionRenderer, item: LazyCompletionItem): void;
    private swap_adapter;
    connect_completion(adapter: WidgetAdapter<IDocumentWidget>, data?: IDocumentConnectionData): void;
    protected get completer(): import("@jupyterlab/completer").Completer;
    protected get model(): LSPCompleterModel;
    invoke_completer(kind: ExtendedCompletionTriggerKind): Promise<any>;
    set_connector(adapter: WidgetAdapter<IDocumentWidget>, editor_changed: IEditorChangedData): void;
    private get current_items();
    private get current_index();
    refresh_doc_panel(item: LazyCompletionItem): void;
    set_doc_panel_placeholder(enable: boolean): void;
    private set_completion_connector;
}
