import { Completer } from '@jupyterlab/completer';
import { CompletionLabIntegration } from './completion';
import { Signal } from '@lumino/signaling';
import { IRenderMime } from '@jupyterlab/rendermime';
import { ILSPLogConsole } from '../../tokens';
import { LazyCompletionItem } from './item';
export declare class LSPCompletionRenderer extends Completer.Renderer implements Completer.IRenderer {
    protected options: LSPCompletionRenderer.IOptions;
    activeChanged: Signal<LSPCompletionRenderer, LazyCompletionItem>;
    constructor(options: LSPCompletionRenderer.IOptions);
    createCompletionItemNode(item: LazyCompletionItem, orderedTypes: string[]): HTMLLIElement;
    createDocumentationNode(item: LazyCompletionItem): HTMLElement;
}
export declare namespace LSPCompletionRenderer {
    interface IOptions {
        integrator: CompletionLabIntegration;
        markdownRenderer: IRenderMime.IRenderer;
        latexTypesetter?: IRenderMime.ILatexTypesetter;
        console: ILSPLogConsole;
    }
}
