import * as lsProtocol from 'vscode-languageserver-protocol';
import { DiagnosticsCM } from './diagnostics/diagnostics';
import { CodeMirrorIntegration, IEditOutcome } from '../editor_integration/codemirror';
import { JupyterFrontEndPlugin } from '@jupyterlab/application';
import { CodeMirrorVirtualEditor } from '../virtual/codemirror_editor';
import { LabIcon } from '@jupyterlab/ui-components';
export declare const renameIcon: LabIcon;
export declare class RenameCM extends CodeMirrorIntegration {
    setStatus(message: string, timeout: number): void;
    handleRename(workspaceEdit: lsProtocol.WorkspaceEdit, old_value: string, new_value: string): Promise<IEditOutcome>;
    /**
     * In #115 an issue with rename for Python (when using pyls) was identified:
     * rename was failing with an obscure message when the source code could
     * not be parsed correctly by rope (due to a user's syntax error).
     *
     * This function detects such a condition using diagnostics feature
     * and provides a nice error message to the user.
     */
    static ux_workaround_for_rope_limitation(error: any, diagnostics_feature: DiagnosticsCM, editor: CodeMirrorVirtualEditor, rename_feature: RenameCM): string;
}
export declare const RENAME_PLUGIN: JupyterFrontEndPlugin<void>;
