import { ICodeOverride, replacer } from './tokens';
declare abstract class OverridesMap extends Map<RegExp, string | replacer> {
    protected constructor(magic_overrides: ICodeOverride[]);
    abstract override_for(code: string): string | null;
    protected _override_for(code: string): string | null;
}
export declare class ReversibleOverridesMap extends OverridesMap {
    private overrides;
    constructor(magic_overrides: ICodeOverride[]);
    get reverse(): OverridesMap;
    type(overrides: ICodeOverride[]): ReversibleOverridesMap;
    override_for(cell: string): string | null;
    replace_all(raw_lines: string[], map?: OverridesMap): {
        lines: string[];
        skip_inspect: boolean[];
    };
    reverse_replace_all(raw_lines: string[]): string[];
}
export {};
